<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBestPracticeRecord ArrayType
 * @subpackage Arrays
 */
class ArrayOfBestPracticeRecord extends AbstractStructArrayBase
{
    /**
     * The BestPracticeRecord
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\BestPracticeRecord[]
     */
    public $BestPracticeRecord;
    /**
     * Constructor method for ArrayOfBestPracticeRecord
     * @uses ArrayOfBestPracticeRecord::setBestPracticeRecord()
     * @param \CustomerManagement\StructType\BestPracticeRecord[] $bestPracticeRecord
     */
    public function __construct(array $bestPracticeRecord = array())
    {
        $this
            ->setBestPracticeRecord($bestPracticeRecord);
    }
    /**
     * Get BestPracticeRecord value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\BestPracticeRecord[]|null
     */
    public function getBestPracticeRecord()
    {
        return isset($this->BestPracticeRecord) ? $this->BestPracticeRecord : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBestPracticeRecord method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBestPracticeRecord method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBestPracticeRecordForArrayConstraintsFromSetBestPracticeRecord(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBestPracticeRecordBestPracticeRecordItem) {
            // validation for constraint: itemType
            if (!$arrayOfBestPracticeRecordBestPracticeRecordItem instanceof \CustomerManagement\StructType\BestPracticeRecord) {
                $invalidValues[] = is_object($arrayOfBestPracticeRecordBestPracticeRecordItem) ? get_class($arrayOfBestPracticeRecordBestPracticeRecordItem) : sprintf('%s(%s)', gettype($arrayOfBestPracticeRecordBestPracticeRecordItem), var_export($arrayOfBestPracticeRecordBestPracticeRecordItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BestPracticeRecord property can only contain items of type \CustomerManagement\StructType\BestPracticeRecord, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BestPracticeRecord value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\BestPracticeRecord[] $bestPracticeRecord
     * @return \CustomerManagement\ArrayType\ArrayOfBestPracticeRecord
     */
    public function setBestPracticeRecord(array $bestPracticeRecord = array())
    {
        // validation for constraint: array
        if ('' !== ($bestPracticeRecordArrayErrorMessage = self::validateBestPracticeRecordForArrayConstraintsFromSetBestPracticeRecord($bestPracticeRecord))) {
            throw new \InvalidArgumentException($bestPracticeRecordArrayErrorMessage, __LINE__);
        }
        if (is_null($bestPracticeRecord) || (is_array($bestPracticeRecord) && empty($bestPracticeRecord))) {
            unset($this->BestPracticeRecord);
        } else {
            $this->BestPracticeRecord = $bestPracticeRecord;
        }
        return $this;
    }
    /**
     * Add item to BestPracticeRecord value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\BestPracticeRecord $item
     * @return \CustomerManagement\ArrayType\ArrayOfBestPracticeRecord
     */
    public function addToBestPracticeRecord(\CustomerManagement\StructType\BestPracticeRecord $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\BestPracticeRecord) {
            throw new \InvalidArgumentException(sprintf('The BestPracticeRecord property can only contain items of type \CustomerManagement\StructType\BestPracticeRecord, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BestPracticeRecord[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\BestPracticeRecord|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\BestPracticeRecord|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\BestPracticeRecord|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\BestPracticeRecord|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\BestPracticeRecord|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BestPracticeRecord
     */
    public function getAttributeName()
    {
        return 'BestPracticeRecord';
    }
}
